﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BaseDataGrid
{
    public class ViewModel
    {
        static Random r = new Random();
        public ObservableCollection<GridData> Data { get; set; }
        private int NoLevels = 7;
        public ViewModel()
        {
            CreateData();

        }

        private string[] names = { "John", "Kim", "Sandy", "Mark", "Josh", "Jim", "Sam", "Mary", 
                                     "Harry", "Sue", "Chris", "Joe", "Carl" };
        private string[] recDescs = { "Test", "Duplicate", "Standard", "Trial", "Expired", "New", "History" };
        private void CreateData()
        {
            Random r = new Random();
            Data = new ObservableCollection<GridData>();
            GridData gd = new GridData()
                {
                    ID = 1,
                    Name = names[r.Next(13)],
                    RecDesc = recDescs[r.Next(7)],
                    RecDate = DateTime.Today.AddDays(r.Next(10)),
                    Children = new ObservableCollection<GridData>(),
                    Children2 = new ObservableCollection<DataLeve2>()
                };

            gd.Children.Add(new GridData()
            {
                ID = 2,
                Name = names[r.Next(13)],
                RecDesc = recDescs[r.Next(7)],
                RecDate = DateTime.Today.AddDays(r.Next(10)),
                Children = new ObservableCollection<GridData>(),
                Children2 = new ObservableCollection<DataLeve2>()
            });

            gd.Children2.Add(new DataLeve2() { Name = "First Child B" });

            Data.Add(gd);
            gd = new GridData()
            {
                ID = 3,
                Name = names[r.Next(13)],
                RecDesc = recDescs[r.Next(7)],
                RecDate = DateTime.Today.AddDays(r.Next(10)),
                Children = new ObservableCollection<GridData>(),
                Children2 = new ObservableCollection<DataLeve2>()
            };

            gd.Children.Add(new GridData()
            {
                ID = 4,
                Name = names[r.Next(13)],
                RecDesc = recDescs[r.Next(7)],
                RecDate = DateTime.Today.AddDays(r.Next(10)),
                Children = new ObservableCollection<GridData>(),
                Children2 = new ObservableCollection<DataLeve2>()
            });

           

            Data.Add(gd);

             gd = new GridData()
            {
                ID = 7,
                Name = names[r.Next(13)],
                RecDesc = recDescs[r.Next(7)],
                RecDate = DateTime.Today.AddDays(r.Next(10)),
                Children = new ObservableCollection<GridData>(),
                Children2 = new ObservableCollection<DataLeve2>()
            };

          

            gd.Children2.Add(new DataLeve2() { Name = "First Child A" });

            Data.Add(gd);

            gd = new GridData()
            {
                ID = 17,
                Name = names[r.Next(13)],
                RecDesc = recDescs[r.Next(7)],
                RecDate = DateTime.Today.AddDays(r.Next(10)),
                Children = new ObservableCollection<GridData>(),
                Children2 = new ObservableCollection<DataLeve2>()
            };

            Data.Add(gd);



        }
        
    }
    public class GridData : INotifyPropertyChanged
    {

        private int id;
        private string name;
        private DateTime recDt;
        private string rec_desc;
        public ObservableCollection<DataLeve2> Children2 { get; set; }
        public ObservableCollection<GridData> Children { get; set; }

        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }

        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public string RecDesc
        {
            get { return rec_desc; }
            set
            {
                if (rec_desc != value)
                {
                    rec_desc = value;
                    OnPropertyChanged("RecDesc");
                }
            }
        }

        public DateTime RecDate
        {
            get { return recDt; }
            set
            {
                if (recDt != value)
                {
                    recDt = value;
                    OnPropertyChanged("RecDate");
                }
            }
        }



        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class DataLeve2
    {
        public string Name { get; set; }
    }
}